SystemOrganization addCategory: #'FuelMooseExtension-Finder'!
SystemOrganization addCategory: #'FuelMooseExtension-Tests'!

!MooseModel classSide methodsFor: '*FuelMooseExtension' stamp: 'MartinDias 11/24/2010 15:13'!
exportFL: aModel to: aStream
	self exportFL: aModel withMetamodel: self meta to: aStream! !

!MooseModel classSide methodsFor: '*FuelMooseExtension' stamp: 'MartinDias 12/30/2010 17:51'!
exportFL: aModel withMetamodel: aMetamodel to: aStream

	[ FLSerializer 
		on: aStream binary
		serialize: aModel 
		descriptedWith: aMetamodel ] valueDisplayingProgress: 'Exporting to FL'! !

!MooseModel classSide methodsFor: '*FuelMooseExtension' stamp: 'MartinDias 11/24/2010 15:18'!
importFromFL: aStream

	^ self importFromFL: aStream withMetamodel: self meta! !

!MooseModel classSide methodsFor: '*FuelMooseExtension' stamp: 'MartinDias 12/30/2010 17:52'!
importFromFL: aStream withMetamodel: aMetamodel

	[ ^ (FLMaterializer on: aStream binary) 
		materializeMooseModelDescriptedWith: aMetamodel ] valueDisplayingProgress: 'Importing from FL'! !

!MooseModel methodsFor: '*FuelMooseExtension' stamp: 'MartinDias 11/24/2010 15:11'!
exportToFL
	<menuItem: 'Export model to FL' category: 'Import / Export'>
	| stream |
	stream := UITheme builder 
		fileSave: 'Your title here'
		extensions: #('fl')
		path: nil.
	stream isNil ifFalse: [ 
		self exportToFLStream: stream.
		stream close.
		Notification signal: 'Save successful!!' ]! !

!MooseModel methodsFor: '*FuelMooseExtension' stamp: 'MartinDias 11/24/2010 15:13'!
exportToFLStream: aStream 

	self class 
		exportFL: self
		to: aStream! !

!MooseModel methodsFor: '*FuelMooseExtension' stamp: 'MartinDias 11/24/2010 15:21'!
importFromFL

	<menuItem: 'Import from FL' category: 'Import / Export'>
	| stream |	
	stream := UITheme builder
		fileOpen: 'Import model from Fuel file' 
		extensions: #('fl').
	stream isNil ifFalse: [
		self name: (FileDirectory baseNameFor: stream localName).
		self importFromFLStream: stream.
		stream close ]! !

!MooseModel methodsFor: '*FuelMooseExtension' stamp: 'MartinDias 11/24/2010 15:21'!
importFromFLStream: aStream
	
	| repository |
	repository := self class importFromFL: aStream.
	repository elements do: [ :e | self add: e ].
	self entityStorage forRuntime! !

MPImportCommand subclass: #FLMooseImportCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMooseExtension-Finder'!

!FLMooseImportCommand methodsFor: 'hooks' stamp: 'MartinDias 11/24/2010 15:24'!
execute
	| model |
	model := MooseModel new.
	model importFromFL.
	model size > 0 ifTrue: [
		model install.
		self addModel: model ]! !

!FLMooseImportCommand methodsFor: 'hooks' stamp: 'MartinDias 2/15/2011 14:30'!
icon
	^ MooseIcons mooseImportFuel! !

!FLMooseImportCommand methodsFor: 'hooks' stamp: 'MartinDias 11/24/2010 15:25'!
informationText
	^ 'Imports from a Fuel file.'! !

!FLMooseImportCommand methodsFor: 'hooks' stamp: 'MartinDias 11/24/2010 15:25'!
label
	^ 'Import from FL'! !

!BlockClosure methodsFor: '*FuelMooseExtension' stamp: 'MartinDias 12/30/2010 17:51'!
valueDisplayingProgress: aStringOrBlock
	"Values the block showing an empty progress bar"

	self flag: 'Fix this!!'.
	#(nil) do: [ :x | self value ] displayingProgress: aStringOrBlock
! !

FLSerializationTest subclass: #FLMooseSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMooseExtension-Tests'!

!FLMooseSerializationTest methodsFor: 'running' stamp: 'MartinDias 2/15/2011 11:29'!
isMerlinPackage: anObject

	^ (anObject class = FAMIXPackage) and: 
		[ anObject name = #Merlin ]! !

!FLMooseSerializationTest methodsFor: 'running' stamp: 'MartinDias 11/25/2010 18:43'!
isSampleFamixAccess: anObject

	^ ((anObject class = FAMIXAccess and: 
		[ anObject variable name = #self ]) and: 
		[ anObject accessor name = #hash ]) and:
		[ anObject accessor parentType name = #FLPair ]! !

!FLMooseSerializationTest methodsFor: 'running' stamp: 'MartinDias 11/18/2010 16:33'!
merlinMooseModel

	^ MooseSqueakClassPackageImporterTask new
		model: MooseModel new;
		addFromPackageNamed: #Merlin;
		run;
		model.
! !

!FLMooseSerializationTest methodsFor: 'tests' stamp: 'MartinDias 11/17/2010 12:52'!
mooseMaterializationOn: aStream

	| tower |
	tower := FMCompleteTower new.
	tower metamodel addAll: MooseModel meta elements.
	FLFameObjectClusterSerializer instance repository: tower model.
	
	^ self materializationOn: aStream! !

!FLMooseSerializationTest methodsFor: 'tests' stamp: 'MartinDias 11/24/2010 11:36'!
mooseSerializationOf: mooseModelEntities

	FLFameObjectClusterSerializer instance repository: 
		((FMRepository with: MooseModel meta) 
			addAll: mooseModelEntities;
			yourself).

	^ (self serializer 
		serialize: mooseModelEntities
		analyzer: FLFameAnalyzer newDefault) 
			stream
! !

!FLMooseSerializationTest methodsFor: 'running' stamp: 'MartinDias 11/25/2010 18:41'!
simpleMooseModel

	^ MooseSqueakClassPackageImporterTask new
		model: MooseModel new;
		addClass: FLPair;
		run;
		model.
! !

!FLMooseSerializationTest methodsFor: 'tests' stamp: 'MartinDias 2/15/2011 11:26'!
testMerlinMooseModelEntities

	| stream original result |
	original := self merlinMooseModel entities.

	self assert: 1 equals: (original count: [ :anEntity | self isMerlinPackage: anEntity ]). 

	stream := self mooseSerializationOf: original.
	result := self mooseMaterializationOn: stream reset.

	self assert: result notNil.
	self assert: original size equals: result size.
	self assert: 1 equals: (original count: [ :anEntity | self isMerlinPackage: anEntity ]). 
	self assert: 1 equals: (result count: [ :anEntity | self isMerlinPackage: anEntity ]).
! !

!FLMooseSerializationTest methodsFor: 'tests' stamp: 'MartinDias 11/24/2010 10:50'!
testSimpleMooseModelEntities

	| stream original result |
	original := self simpleMooseModel entities.

	self assert: 2 equals: (original count: [ :anEntity | self isSampleFamixAccess: anEntity ]). 

	stream := self mooseSerializationOf: original.
	result := self mooseMaterializationOn: stream reset.

	self assert: result notNil.
	self assert: original size equals: result size.
	self assert: 2 equals: (original count: [ :anEntity | self isSampleFamixAccess: anEntity ]). 
	self assert: 2 equals: (result count: [ :anEntity | self isSampleFamixAccess: anEntity ]).
! !

!FLMaterializer methodsFor: '*FuelMooseExtension' stamp: 'MartinDias 12/30/2010 16:46'!
materializeMooseModelDescriptedWith: aMetamodel

	| entities tower |
	tower := FMCompleteTower new.
	tower metamodel addAll: aMetamodel elements.

	FLFameObjectClusterSerializer instance repository: tower model.
	entities := self materialize; root.

	tower model addAll: entities.
	tower model updateCache.
	^ tower model! !

!FLSerializer class methodsFor: '*FuelMooseExtension' stamp: 'MartinDias 12/30/2010 17:35'!
on: aStream serialize: aMooseModel descriptedWith: aMetamodel

	| bufferStream |
	bufferStream := ByteArray new writeStream.

	(self on: bufferStream)
		serialize: aMooseModel
		descriptedWith: aMetamodel.

	aStream nextPutAll: bufferStream contents.			! !

!FLSerializer methodsFor: '*FuelMooseExtension' stamp: 'MartinDias 12/30/2010 15:50'!
serialize: aMooseModel descriptedWith: aMetamodel

	FLFameObjectClusterSerializer instance repository: 
		((FMRepository with: aMetamodel) 
			addAll: aMooseModel entities;
			yourself).
	self
		serialize: aMooseModel entities
		analyzer: FLFameAnalyzer newDefault.
			! !
